/***************************************************************************
                          HipSupportMissing.h  -  description
                             -------------------
    begin                : Jun 17, 2020
    copyright            : (C) 2020 by Tomas Oberhuber et al.
    email                : tomas.oberhuber@fjfi.cvut.cz
 ***************************************************************************/

/* See Copyright Notice in tnl/Copyright */

// Implemented by: Jakub Klinkovsky

#pragma once

#include <stdexcept>

namespace TNL {
/**
 * \brief Namespace for TNL exceptions.
 */
namespace Exceptions {

struct HipSupportMissing
   : public std::runtime_error
{
   HipSupportMissing()
   : std::runtime_error( "HIP support is missing, but the program called a function which needs it. "
                         "Please recompile the program with HIP support." )
   {}
};

} // namespace Exceptions
} // namespace TNL
