/***************************************************************************
                          DeviceInfo.h  -  description
                             -------------------
    begin                : Jun 17, 2020
    copyright            : (C) 2020 by Tomas Oberhuber
    email                : tomas.oberhuber@fjfi.cvut.cz
 ***************************************************************************/

/* See Copyright Notice in tnl/Copyright */

#pragma once

#include <TNL/String.h>

namespace TNL {
namespace Hip {

struct DeviceInfo
{
   static int getNumberOfDevices();

   static int getActiveDevice();

   static String getDeviceName( int deviceNum );

   static int getArchitectureMajor( int deviceNum );

   static int getArchitectureMinor( int deviceNum );

   static int getClockRate( int deviceNum );

   static std::size_t getGlobalMemory( int deviceNum );

   static std::size_t getFreeGlobalMemory();

   static int getMemoryClockRate( int deviceNum );

   static bool getECCEnabled( int deviceNum );

   static int getHipMultiprocessors( int deviceNum );

   static int getHipCoresPerMultiprocessors( int deviceNum );

   static int getHipCores( int deviceNum );

   static int getRegistersPerMultiprocessor( int deviceNum );
};

} // namespace Hip
} // namespace TNL

#include <TNL/Hip/DeviceInfo.hpp>
